Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4723)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4724)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! - New routines to read LOD=1 variables from dynamic input file
+! - add no_abort option to all get_attribute routines
+!
+! 4641 2020-08-13 09:57:07Z suehring
 ! To follow (UC)2 standard, change default of attribute data_content
 ! 
@@ -741,4 +745,5 @@
        MODULE PROCEDURE get_variable_2d_int32
        MODULE PROCEDURE get_variable_2d_real
+       MODULE PROCEDURE get_variable_2d_real_dynamic
        MODULE PROCEDURE get_variable_3d_int8
        MODULE PROCEDURE get_variable_3d_real
@@ -3996,5 +4001,5 @@
 !------------------------------------------------------------------------------!
      SUBROUTINE get_attribute_int32( id, attribute_name, value, global,        &
-                                     variable_name )
+                                     variable_name, no_abort )
 
        USE pegrid
@@ -4009,12 +4014,19 @@
        INTEGER(iwp), INTENT(INOUT) ::  value            !< read value
 
-       LOGICAL, INTENT(IN) ::  global                   !< flag indicating global attribute
+       LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
+       LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
+       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
 #if defined( __netcdf )
 
+       IF ( PRESENT( no_abort ) )  THEN
+          check_error = no_abort
+       ELSE
+          check_error = .TRUE.
+       ENDIF
 !
 !--    Read global attribute
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int32 global', 522, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_int32 global', 522, attribute_name )
 !
 !--    Read attributes referring to a single variable. Therefore, first inquire
@@ -4022,7 +4034,7 @@
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_int32', 522, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_int32', 522, attribute_name )
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int32', 522, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_int32', 522, attribute_name )
        ENDIF
 #endif
@@ -4035,5 +4047,5 @@
 !------------------------------------------------------------------------------!
      SUBROUTINE get_attribute_int8( id, attribute_name, value, global,         &
-                                    variable_name )
+                                    variable_name, no_abort )
 
        USE pegrid
@@ -4048,12 +4060,19 @@
        INTEGER(KIND=1), INTENT(INOUT) ::  value         !< read value
 
-       LOGICAL, INTENT(IN) ::  global                   !< flag indicating global attribute
+       LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
+       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
+       LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
 #if defined( __netcdf )
 
+       IF ( PRESENT( no_abort ) )  THEN
+          check_error = no_abort
+       ELSE
+          check_error = .TRUE.
+       ENDIF
 !
 !--    Read global attribute
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int8 global', 523, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_int8 global', 523, attribute_name )
 !
 !--    Read attributes referring to a single variable. Therefore, first inquire
@@ -4061,7 +4080,7 @@
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_int8', 523, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_int8', 523, attribute_name )
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_int8', 523, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_int8', 523, attribute_name )
        ENDIF
 #endif
@@ -4074,5 +4093,5 @@
 !------------------------------------------------------------------------------!
      SUBROUTINE get_attribute_real( id, attribute_name, value, global,         &
-                                    variable_name )
+                                    variable_name, no_abort )
 
        USE pegrid
@@ -4086,23 +4105,29 @@
        INTEGER(iwp)                ::  id_var           !< variable id
 
-       LOGICAL, INTENT(IN) ::  global                   !< flag indicating global attribute
+       LOGICAL                       ::  check_error    !< flag indicating if handle_error shall be checked
+       LOGICAL, INTENT(IN)           ::  global         !< flag indicating global attribute
+       LOGICAL, INTENT(IN), OPTIONAL ::  no_abort       !< flag indicating if errors should be checked
 
        REAL(wp), INTENT(INOUT)     ::  value            !< read value
 #if defined( __netcdf )
 
-
-!
-!-- Read global attribute
+       IF ( PRESENT( no_abort ) )  THEN
+          check_error = no_abort
+       ELSE
+          check_error = .TRUE.
+       ENDIF
+!
+!--    Read global attribute
        IF ( global )  THEN
           nc_stat = NF90_GET_ATT( id, NF90_GLOBAL, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_real global', 524, attribute_name )
-!
-!-- Read attributes referring to a single variable. Therefore, first inquire
-!-- variable id
+          IF ( check_error)  CALL handle_error( 'get_attribute_real global', 524, attribute_name )
+!
+!--    Read attributes referring to a single variable. Therefore, first inquire
+!--    variable id
        ELSE
           nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
-          CALL handle_error( 'get_attribute_real', 524, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_real', 524, attribute_name )
           nc_stat = NF90_GET_ATT( id, id_var, TRIM( attribute_name ), value )
-          CALL handle_error( 'get_attribute_real', 524, attribute_name )
+          IF ( check_error)  CALL handle_error( 'get_attribute_real', 524, attribute_name )
        ENDIF
 #endif
@@ -4332,7 +4357,7 @@
 
 !------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Reads a character variable in a 1D array
+!    Description:
+!    ------------
+!>   Reads a character variable in a 1D array
 !------------------------------------------------------------------------------!
      SUBROUTINE get_variable_1d_char( id, variable_name, var )
@@ -4405,5 +4430,5 @@
        CALL handle_error( 'get_variable_1d_int', 527, variable_name )
 !
-!--    Inquire dimension length
+!--    Read variable
        nc_stat = NF90_GET_VAR( id, id_var, var )
        CALL handle_error( 'get_variable_1d_int', 527, variable_name )
@@ -4417,5 +4442,5 @@
 !> Reads a 1D float variable from file.
 !------------------------------------------------------------------------------!
-     SUBROUTINE get_variable_1d_real( id, variable_name, var )
+     SUBROUTINE get_variable_1d_real( id, variable_name, var, is, count_elements )
 
        USE pegrid
@@ -4428,7 +4453,9 @@
        INTEGER(iwp)                ::  id_var           !< dimension id
 
+       INTEGER(iwp), INTENT(IN), OPTIONAL ::  count_elements !< number of elements to be read
+       INTEGER(iwp), INTENT(IN), OPTIONAL ::  is             !< start index
+
        REAL(wp), DIMENSION(:), INTENT(INOUT) ::  var    !< variable to be read
 #if defined( __netcdf )
-
 !
 !--    First, inquire variable ID
@@ -4436,7 +4463,12 @@
        CALL handle_error( 'get_variable_1d_real', 528, variable_name )
 !
-!--    Inquire dimension length
-       nc_stat = NF90_GET_VAR( id, id_var, var )
-       CALL handle_error( 'get_variable_1d_real', 528, variable_name )
+!--    Read variable
+       IF ( PRESENT( is ) )  THEN
+          nc_stat = NF90_GET_VAR( id, id_var, var, start = (/ is /), count = (/ count_elements /) )
+          CALL handle_error( 'get_variable_1d_real', 528, variable_name )
+       ELSE
+          nc_stat = NF90_GET_VAR( id, id_var, var )
+          CALL handle_error( 'get_variable_1d_real', 528, variable_name )
+       ENDIF
 
 #endif
@@ -4463,5 +4495,5 @@
        INTEGER(iwp), INTENT(IN)              ::  t                !< timestep number
 
-       REAL(wp), DIMENSION(:), INTENT(INOUT) ::  var  !< variable to be read
+       REAL(wp), DIMENSION(:), INTENT(INOUT) ::  var              !< variable to be read
 
 #if defined( __netcdf )
@@ -4743,21 +4775,21 @@
 
 !
-!-- Allocate temporary variable according to memory access on file. 
+!--    Allocate temporary variable according to memory access on file. 
        ALLOCATE( tmp(is:ie,js:je) )
 !
-!-- Get variable
+!--    Get variable
        nc_stat = NF90_GET_VAR( id, id_var, tmp,            &
                       start = (/ is+1,      js+1 /),       &
                       count = (/ ie-is + 1, je-js+1 /) )   
-          CALL handle_error( 'get_variable_2d_real', 530, variable_name )
-!
-!-- Resort data. Please note, dimension subscripts of var all start at 1. 
-          DO  i = is, ie 
-             DO  j = js, je 
-                var(j-js+1,i-is+1) = tmp(i,j)
-             ENDDO
+       CALL handle_error( 'get_variable_2d_real', 530, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je 
+             var(j-js+1,i-is+1) = tmp(i,j)
           ENDDO
+       ENDDO
        
-          DEALLOCATE( tmp )
+       DEALLOCATE( tmp )
 
 #endif
@@ -5171,4 +5203,74 @@
 #endif
     END SUBROUTINE get_variable_4d_to_3d_real
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a 3D float variables from dynamic driver with the last dimension only
+!> having 1 entry (time,z). Please note, 
+!> the passed arguments are start indices and number of elements in each 
+!> dimension, which is in contrast to the other 3d versions where start- and 
+!> end indices are passed. The different handling compared to get_variable_2d_real
+!> is due to its different start-index treatment.
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_2d_real_dynamic( id, variable_name, var,           &
+                                             i1s, i2s,                         &
+                                             count_1, count_2 )
+                                
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*)              ::  variable_name   !< variable name
+
+       INTEGER(iwp)                  ::  count_1         !< number of elements to be read along 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  count_2         !< number of elements to be read along 2nd dimension (with respect to file)
+       INTEGER(iwp)                  ::  i1              !< running index along 1st dimension on file
+       INTEGER(iwp)                  ::  i1s             !< start index for subdomain input along 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  i2              !< running index along 2nd dimension on file       
+       INTEGER(iwp)                  ::  i2s             !< start index for subdomain input along 2nd dimension (with respect to file)
+       INTEGER(iwp), INTENT(IN)      ::  id              !< file id
+       INTEGER(iwp)                  ::  id_var          !< variable id
+       INTEGER(iwp)                  ::  lb1             !< lower bound of 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  lb2             !< lower bound of 2nd dimension (with respect to file)
+       INTEGER(iwp)                  ::  ub1             !< upper bound of 1st dimension (with respect to file)
+       INTEGER(iwp)                  ::  ub2             !< upper bound of 2nd dimension (with respect to file)
+
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  tmp   !< temporary variable to read data from file according to its reverse memory access
+
+       REAL(wp), DIMENSION(:,:,:), INTENT(INOUT) ::  var !< input variable
+
+#if defined( __netcdf )
+!
+!--    Inquire variable id.
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+!
+!--    Allocate temporary variable according to memory access on file. 
+!--    Therefore, determine dimension bounds of input array. 
+       lb1 = LBOUND(var,2)
+       ub1 = UBOUND(var,2)
+       lb2 = LBOUND(var,1)
+       ub2 = UBOUND(var,1)
+
+       ALLOCATE( tmp(lb1:ub1,lb2:ub2) )
+!
+!--    Get variable
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                               start = (/ i1s,     i2s /),                     &
+                               count = (/ count_1, count_2 /) )
+
+       CALL handle_error( 'get_variable_2d_real_dynamic', 537, variable_name )
+!
+!--    Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO i2 = lb2, ub2
+          DO  i1 = lb1, ub1
+             var(i2,i1,1) = tmp(i1,i2)
+          ENDDO
+       ENDDO
+
+       DEALLOCATE( tmp )       
+#endif
+    END SUBROUTINE get_variable_2d_real_dynamic
 
 !------------------------------------------------------------------------------!
